import { Directive, ElementRef, HostListener, Input, Inject, Renderer2 } from '@angular/core';
import { DOCUMENT } from '@angular/platform-browser';

/**
 * monitor document scroll event
 * and show or hide an element based on its position relative to the document
 * based on an optionally provided threshold
 */
@Directive({
  selector: '[cScrollSpy]' //<a [cScrollSpy]="100px">Sample</a>
})
export class ScrollSpyDirective {

  constructor(private el: ElementRef, private renderer: Renderer2, @Inject(DOCUMENT) private document: Document){}
  
  @Input('cScrollSpy') threshold: number = 150;

  @HostListener('window:scroll', ['$event']) onScroll(event){
    let display = (this.document.body.scrollTop > this.threshold) ? 'block' : 'none';
    this.renderer.setStyle(this.el.nativeElement, 'display', display);
  }

}
