import { Injectable } from '@angular/core';
import { CanActivateChild, 
        Router,
        ActivatedRouteSnapshot,
        RouterStateSnapshot } from '@angular/router';
import { AuthService } from '../services';
import { AuthGuard } from "./auth.guard";

@Injectable()
export class AuthChildGuard extends AuthGuard implements CanActivateChild{
    
    constructor(protected router: Router, protected auth: AuthService){
        super(router, auth);
    }

    canActivateChild(route: ActivatedRouteSnapshot, state: RouterStateSnapshot): boolean{
        return this.canActivate(route, state);
    }
}