import { Injectable } from '@angular/core';
import { RuleContract, ConditionContract, FilterContract } from "./contracts";
import { HelperService } from "../helper";
// import { Agent } from "../agent";
import { StorageService } from "../storage";

@Injectable()
export class CleverQueryService{

    private conditions: ConditionContract[];
    private joiners: ('and' | 'or')[];
    private filters: FilterContract[];
    
    private query: string;
    private domain: string[];
    private operatorsNValues: { operator: string; value: string }[];
    private categories: string[];
    private sorters: { operator: 'asc' | 'desc'; column: string }[];

    private limit: number = 6;
    constructor(
        private _: HelperService,
        // private agent: Agent, 
        private store: StorageService){
        this.store = this.store.local();
    }
    
    simple(conditions: ConditionContract[] = null, joiners: ('and' | 'or')[] = null, page: number = 1, limit?: number){
        limit = (limit) ? limit : this.limit;
        this.conditions = conditions;
        this.joiners = joiners;
        this.filters = [{ order: ['id', 'desc']}, { limit: limit }, { offset: limit*(page - 1) }];

        return this.make();
    }

    advance(conditions: ConditionContract[] = null, joiners: ('and' | 'or')[] = null, filters: FilterContract[]){
        this.conditions = conditions;
        this.joiners = joiners;
        this.filters = (filters) ? filters : [{ order: ['id', 'desc']}, { limit: this.limit }, { offset: 0 }];

        return this.make();
    }
    
    make(){
        return {
            conditions: this.conditions,
            joiners: this.joiners,
            filters: this.filters
        };
    }

    init(){
        //get all niche domains and store
        // this.agent.go((agent) => {
            // agent.domain().rows((response) => {
            //     this.store.set('cqDomain', response['domains']);
            // });
        // });

        //get all niche categories and store
        // this.agent.go((agent) => {
            // agent.domain().rows((response) => {
            //     this.store.set('cqDomain', response['domains']);
            // });
        // });
    }
    
    fromString(query: string){
        this.query = query;
        this.lookForDomains();
        this.lookForOperatorsNValues();
        this.lookForCategories();
        this.lookForSorters();
    }

    /**
     *Search for, and cut out all occurrence of niches' domain host name 
     * (or equivalent shortcut). Convert result to an query rules/conditions.
     * 
     */
    private lookForDomains(){}

    /**
     * Search for, and cut out <,>,<=,>=,= and the next sequence of xters. 
     * Use the key, value pair to form a query of date or time depending on the value guessed type.
     */
    private lookForOperatorsNValues(){}
    
    /**
     * Search for and cut out all occurrence of niches type, like video, 
     * music for episode, use the result to form a rule. 
     */
    private lookForCategories(){}

    /**
     * Search for ~|+- and cut out with the next sequence of xters. 
     * Use the pair to create filters that sort result by columns ASC,+, or DESC,-.
     */    
    private lookForSorters(){}

    // Get search string
    // ----
    // $niches => where niche_id in []
    // $operators&values => => orderby operator value || => where stuff->time in []
    // $types => where stuff->type  in []
    // private query: string;
    // private keywords: string[]; 
    // private domains: string[]; //d e.g jumia, punch
    // private orderBy: string[]; //o,! e.g asc, desc
    // private categories: string[]; //c e.g video, phone
    // private range: Object; //price, size etc //r,<,>,= e.g 50000
    // private size: string; //s,,<,>,= e.g 43
    triggers: string[];
    triggerGroups: Object[];

    
    /**
     * go thru the trigger and use (the first character of each trigger name + ':') to 
     * extract each triger point (trigger name as key and the gorup as value) into a new array
     */
    group(query: string): Object[]{
        return [];
    }

    // protected getKeywords(): string[]{
    //     return [];
    // }
    // protected getDomains(): string[]{
    //     return [];
    // }
    // protected getOrderBy(): string{
    //     return '';
    // }
    // protected getCategories(): string[]{
    //     return [];
    // }
    // protected getRange(): Object{
    //     //top, bottom
    //     return {
    //         top: 'number|~(infinity)',
    //         bottom: 'number|~(infinity)'
    //     };
    // }

    public setQuery(query: string){
        // this.query = query;
        return this;
    }
    public getCleverQuery(asString: boolean = false): Object[]{
        //take the trigger groups
        //turn it into:
        //{keywords: string, domains(that corresonds to domains name): [strings], 
        //  columns(to search): [string], orderBy: string }
        return [{
            key: '', //columnName
            operator: '', 
            value: ''
        }];
    }  

    /**
     * takes getCleverQuery and turn into raw SQL
     */
    public raw(){
        return;
    }
}


/**
 * let sampleRawQueryObject = {
        conditions: [{
                'and' : [['key', 'operator', 'value'],['key', 'operator', 'value']] 
            },{
                'or' : [['key', 'operator', 'value'],['key', 'operator', 'value']] 
        
            },{
                'year' : [['key', 'operator', 'value'],['key', 'operator', 'value']] 
        
        }],
        joiners: ['and', 'or'],
        filters: [{
                'order': ['column', 'value']
            },{
                'offset': 'number'
            },{
                'limit': 'number'
        }]
    };
 */
