import { Injectable } from '@angular/core';

@Injectable()
export class PaginatorService{
    totalItems;
    currentPage;
    qttyPerPage = 6;
    totalPages;
    startPage;
    pageSize;
    pageNumbers;
    endPage;
    startIndex;
    endIndex;
    
    pager(totalItems:number, currentPage:number = 1){
        this.totalPages = Math.ceil(totalItems/this.qttyPerPage);

        if(this.totalPages <= 10){
            this.startPage = 1;
            this.endPage = this.totalPages;
        }
        else{
            if(this.currentPage <= 6){
                this.startPage = 1;
                this.endPage = 10;
                
            }
            else if(this.currentPage + 4 >= this.totalPages){
                this.startPage = this.totalPages - 9;
                this.endPage = this.totalPages;

            }
            else{
                this.startPage = this.currentPage - 5;
                this.endPage = this.currentPage + 4;

            }
        }

        this.startIndex = (this.currentPage - 1) * this.qttyPerPage;
        this.endIndex = Math.min((this.startIndex + this.qttyPerPage - 1), (this.totalItems - 1));
        this.pageNumbers = Array(Math.ceil(this.totalPages)).fill(0).map((x, i) => i + 1);
        
        return {
            totalItems: totalItems,
            currentPage: currentPage,
            qttyPerPage: this.qttyPerPage,
            totalPages: this.totalPages,
            startPage: this.startPage,
            endPage: this.endPage,
            pageSize: this.pageSize,
            pageNumbers: this.pageNumbers,
            startIndex: this.startIndex,
            endIndex: this.endIndex
        }
    }
    
}