import { Injectable } from '@angular/core';

/**
 * A wrapper around localStorage and sessionStorage
 * to improve ease of use and maintainability.
 * Works with JSON out of the box.
 */
@Injectable()
export class StorageService{

    store: Storage;

    local(){
        this.store = localStorage;
        return this;
    }

    session(){
        this.store = localStorage;
        return this;
    }

    length(): number{
        return this.store.length;
    }

    key(index: number): string{
        return this.store.key(index);
    }

    set(key: string, value: any): void{
        return this.store.setItem(key, JSON.stringify(value));
    }

    get(key: string): any{
        return JSON.parse(this.store.getItem(key));
    }

    remove(key: string): void{
        return this.store.removeItem(key);
    }
    
    clear(): void{
        return this.store.clear();
    }
}
